fdaeb3a96bed361f53030cb6ea5c6bdde445163f
[git/git.git] / t / test-lib-functions.sh
1 # Library of functions shared by all tests scripts, included by
2 # test-lib.sh.
3 #
4 # Copyright (c) 2005 Junio C Hamano
5 #
6 # This program is free software: you can redistribute it and/or modify
7 # it under the terms of the GNU General Public License as published by
8 # the Free Software Foundation, either version 2 of the License, or
9 # (at your option) any later version.
10 #
11 # This program is distributed in the hope that it will be useful,
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14 # GNU General Public License for more details.
15 #
16 # You should have received a copy of the GNU General Public License
17 # along with this program. If not, see http://www.gnu.org/licenses/ .
18
19 # The semantics of the editor variables are that of invoking
20 # sh -c "$EDITOR \"$@\"" files ...
21 #
22 # If our trash directory contains shell metacharacters, they will be
23 # interpreted if we just set $EDITOR directly, so do a little dance with
24 # environment variables to work around this.
25 #
26 # In particular, quoting isn't enough, as the path may contain the same quote
27 # that we're using.
28 test_set_editor () {
29 FAKE_EDITOR="$1"
30 export FAKE_EDITOR
31 EDITOR='"$FAKE_EDITOR"'
32 export EDITOR
33 }
34
35 test_set_index_version () {
36 GIT_INDEX_VERSION="$1"
37 export GIT_INDEX_VERSION
38 }
39
40 test_decode_color () {
41 awk '
42 function name(n) {
43 if (n == 0) return "RESET";
44 if (n == 1) return "BOLD";
45 if (n == 30) return "BLACK";
46 if (n == 31) return "RED";
47 if (n == 32) return "GREEN";
48 if (n == 33) return "YELLOW";
49 if (n == 34) return "BLUE";
50 if (n == 35) return "MAGENTA";
51 if (n == 36) return "CYAN";
52 if (n == 37) return "WHITE";
53 if (n == 40) return "BLACK";
54 if (n == 41) return "BRED";
55 if (n == 42) return "BGREEN";
56 if (n == 43) return "BYELLOW";
57 if (n == 44) return "BBLUE";
58 if (n == 45) return "BMAGENTA";
59 if (n == 46) return "BCYAN";
60 if (n == 47) return "BWHITE";
61 }
62 {
63 while (match($0, /\033\[[0-9;]*m/) != 0) {
64 printf "%s<", substr($0, 1, RSTART-1);
65 codes = substr($0, RSTART+2, RLENGTH-3);
66 if (length(codes) == 0)
67 printf "%s", name(0)
68 else {
69 n = split(codes, ary, ";");
70 sep = "";
71 for (i = 1; i <= n; i++) {
72 printf "%s%s", sep, name(ary[i]);
73 sep = ";"
74 }
75 }
76 printf ">";
77 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
78 }
79 print
80 }
81 '
82 }
83
84 lf_to_nul () {
85 perl -pe 'y/\012/\000/'
86 }
87
88 nul_to_q () {
89 perl -pe 'y/\000/Q/'
90 }
91
92 q_to_nul () {
93 perl -pe 'y/Q/\000/'
94 }
95
96 q_to_cr () {
97 tr Q '\015'
98 }
99
100 q_to_tab () {
101 tr Q '\011'
102 }
103
104 qz_to_tab_space () {
105 tr QZ '\011\040'
106 }
107
108 append_cr () {
109 sed -e 's/$/Q/' | tr Q '\015'
110 }
111
112 remove_cr () {
113 tr '\015' Q | sed -e 's/Q$//'
114 }
115
116 # In some bourne shell implementations, the "unset" builtin returns
117 # nonzero status when a variable to be unset was not set in the first
118 # place.
119 #
120 # Use sane_unset when that should not be considered an error.
121
122 sane_unset () {
123 unset "$@"
124 return 0
125 }
126
127 test_tick () {
128 if test -z "${test_tick+set}"
129 then
130 test_tick=1112911993
131 else
132 test_tick=$(($test_tick + 60))
133 fi
134 GIT_COMMITTER_DATE="$test_tick -0700"
135 GIT_AUTHOR_DATE="$test_tick -0700"
136 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
137 }
138
139 # Stop execution and start a shell. This is useful for debugging tests and
140 # only makes sense together with "-v".
141 #
142 # Be sure to remove all invocations of this command before submitting.
143
144 test_pause () {
145 if test "$verbose" = t; then
146 "$SHELL_PATH" <&6 >&3 2>&4
147 else
148 error >&5 "test_pause requires --verbose"
149 fi
150 }
151
152 # Wrap git in gdb. Adding this to a command can make it easier to
153 # understand what is going on in a failing test.
154 #
155 # Example: "debug git checkout master".
156 debug () {
157 GIT_TEST_GDB=1 "$@"
158 }
159
160 # Call test_commit with the arguments "<message> [<file> [<contents> [<tag>]]]"
161 #
162 # This will commit a file with the given contents and the given commit
163 # message, and tag the resulting commit with the given tag name.
164 #
165 # <file>, <contents>, and <tag> all default to <message>.
166
167 test_commit () {
168 notick= &&
169 signoff= &&
170 while test $# != 0
171 do
172 case "$1" in
173 --notick)
174 notick=yes
175 ;;
176 --signoff)
177 signoff="$1"
178 ;;
179 *)
180 break
181 ;;
182 esac
183 shift
184 done &&
185 file=${2:-"$1.t"} &&
186 echo "${3-$1}" > "$file" &&
187 git add "$file" &&
188 if test -z "$notick"
189 then
190 test_tick
191 fi &&
192 git commit $signoff -m "$1" &&
193 git tag "${4:-$1}"
194 }
195
196 # Call test_merge with the arguments "<message> <commit>", where <commit>
197 # can be a tag pointing to the commit-to-merge.
198
199 test_merge () {
200 test_tick &&
201 git merge -m "$1" "$2" &&
202 git tag "$1"
203 }
204
205 # This function helps systems where core.filemode=false is set.
206 # Use it instead of plain 'chmod +x' to set or unset the executable bit
207 # of a file in the working directory and add it to the index.
208
209 test_chmod () {
210 chmod "$@" &&
211 git update-index --add "--chmod=$@"
212 }
213
214 # Unset a configuration variable, but don't fail if it doesn't exist.
215 test_unconfig () {
216 config_dir=
217 if test "$1" = -C
218 then
219 shift
220 config_dir=$1
221 shift
222 fi
223 git ${config_dir:+-C "$config_dir"} config --unset-all "$@"
224 config_status=$?
225 case "$config_status" in
226 5) # ok, nothing to unset
227 config_status=0
228 ;;
229 esac
230 return $config_status
231 }
232
233 # Set git config, automatically unsetting it after the test is over.
234 test_config () {
235 config_dir=
236 if test "$1" = -C
237 then
238 shift
239 config_dir=$1
240 shift
241 fi
242 test_when_finished "test_unconfig ${config_dir:+-C '$config_dir'} '$1'" &&
243 git ${config_dir:+-C "$config_dir"} config "$@"
244 }
245
246 test_config_global () {
247 test_when_finished "test_unconfig --global '$1'" &&
248 git config --global "$@"
249 }
250
251 write_script () {
252 {
253 echo "#!${2-"$SHELL_PATH"}" &&
254 cat
255 } >"$1" &&
256 chmod +x "$1"
257 }
258
259 # Use test_set_prereq to tell that a particular prerequisite is available.
260 # The prerequisite can later be checked for in two ways:
261 #
262 # - Explicitly using test_have_prereq.
263 #
264 # - Implicitly by specifying the prerequisite tag in the calls to
265 # test_expect_{success,failure,code}.
266 #
267 # The single parameter is the prerequisite tag (a simple word, in all
268 # capital letters by convention).
269
270 test_set_prereq () {
271 satisfied_prereq="$satisfied_prereq$1 "
272 }
273 satisfied_prereq=" "
274 lazily_testable_prereq= lazily_tested_prereq=
275
276 # Usage: test_lazy_prereq PREREQ 'script'
277 test_lazy_prereq () {
278 lazily_testable_prereq="$lazily_testable_prereq$1 "
279 eval test_prereq_lazily_$1=\$2
280 }
281
282 test_run_lazy_prereq_ () {
283 script='
284 mkdir -p "$TRASH_DIRECTORY/prereq-test-dir" &&
285 (
286 cd "$TRASH_DIRECTORY/prereq-test-dir" &&'"$2"'
287 )'
288 say >&3 "checking prerequisite: $1"
289 say >&3 "$script"
290 test_eval_ "$script"
291 eval_ret=$?
292 rm -rf "$TRASH_DIRECTORY/prereq-test-dir"
293 if test "$eval_ret" = 0; then
294 say >&3 "prerequisite $1 ok"
295 else
296 say >&3 "prerequisite $1 not satisfied"
297 fi
298 return $eval_ret
299 }
300
301 test_have_prereq () {
302 # prerequisites can be concatenated with ','
303 save_IFS=$IFS
304 IFS=,
305 set -- $*
306 IFS=$save_IFS
307
308 total_prereq=0
309 ok_prereq=0
310 missing_prereq=
311
312 for prerequisite
313 do
314 case "$prerequisite" in
315 !*)
316 negative_prereq=t
317 prerequisite=${prerequisite#!}
318 ;;
319 *)
320 negative_prereq=
321 esac
322
323 case " $lazily_tested_prereq " in
324 *" $prerequisite "*)
325 ;;
326 *)
327 case " $lazily_testable_prereq " in
328 *" $prerequisite "*)
329 eval "script=\$test_prereq_lazily_$prerequisite" &&
330 if test_run_lazy_prereq_ "$prerequisite" "$script"
331 then
332 test_set_prereq $prerequisite
333 fi
334 lazily_tested_prereq="$lazily_tested_prereq$prerequisite "
335 esac
336 ;;
337 esac
338
339 total_prereq=$(($total_prereq + 1))
340 case "$satisfied_prereq" in
341 *" $prerequisite "*)
342 satisfied_this_prereq=t
343 ;;
344 *)
345 satisfied_this_prereq=
346 esac
347
348 case "$satisfied_this_prereq,$negative_prereq" in
349 t,|,t)
350 ok_prereq=$(($ok_prereq + 1))
351 ;;
352 *)
353 # Keep a list of missing prerequisites; restore
354 # the negative marker if necessary.
355 prerequisite=${negative_prereq:+!}$prerequisite
356 if test -z "$missing_prereq"
357 then
358 missing_prereq=$prerequisite
359 else
360 missing_prereq="$prerequisite,$missing_prereq"
361 fi
362 esac
363 done
364
365 test $total_prereq = $ok_prereq
366 }
367
368 test_declared_prereq () {
369 case ",$test_prereq," in
370 *,$1,*)
371 return 0
372 ;;
373 esac
374 return 1
375 }
376
377 test_verify_prereq () {
378 test -z "$test_prereq" ||
379 expr >/dev/null "$test_prereq" : '[A-Z0-9_,!]*$' ||
380 error "bug in the test script: '$test_prereq' does not look like a prereq"
381 }
382
383 test_expect_failure () {
384 test_start_
385 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
386 test "$#" = 2 ||
387 error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
388 test_verify_prereq
389 export test_prereq
390 if ! test_skip "$@"
391 then
392 say >&3 "checking known breakage: $2"
393 if test_run_ "$2" expecting_failure
394 then
395 test_known_broken_ok_ "$1"
396 else
397 test_known_broken_failure_ "$1"
398 fi
399 fi
400 test_finish_
401 }
402
403 test_expect_success () {
404 test_start_
405 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
406 test "$#" = 2 ||
407 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
408 test_verify_prereq
409 export test_prereq
410 if ! test_skip "$@"
411 then
412 say >&3 "expecting success: $2"
413 if test_run_ "$2"
414 then
415 test_ok_ "$1"
416 else
417 test_failure_ "$@"
418 fi
419 fi
420 test_finish_
421 }
422
423 # test_external runs external test scripts that provide continuous
424 # test output about their progress, and succeeds/fails on
425 # zero/non-zero exit code. It outputs the test output on stdout even
426 # in non-verbose mode, and announces the external script with "# run
427 # <n>: ..." before running it. When providing relative paths, keep in
428 # mind that all scripts run in "trash directory".
429 # Usage: test_external description command arguments...
430 # Example: test_external 'Perl API' perl ../path/to/test.pl
431 test_external () {
432 test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
433 test "$#" = 3 ||
434 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
435 descr="$1"
436 shift
437 test_verify_prereq
438 export test_prereq
439 if ! test_skip "$descr" "$@"
440 then
441 # Announce the script to reduce confusion about the
442 # test output that follows.
443 say_color "" "# run $test_count: $descr ($*)"
444 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
445 # to be able to use them in script
446 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
447 # Run command; redirect its stderr to &4 as in
448 # test_run_, but keep its stdout on our stdout even in
449 # non-verbose mode.
450 "$@" 2>&4
451 if test "$?" = 0
452 then
453 if test $test_external_has_tap -eq 0; then
454 test_ok_ "$descr"
455 else
456 say_color "" "# test_external test $descr was ok"
457 test_success=$(($test_success + 1))
458 fi
459 else
460 if test $test_external_has_tap -eq 0; then
461 test_failure_ "$descr" "$@"
462 else
463 say_color error "# test_external test $descr failed: $@"
464 test_failure=$(($test_failure + 1))
465 fi
466 fi
467 fi
468 }
469
470 # Like test_external, but in addition tests that the command generated
471 # no output on stderr.
472 test_external_without_stderr () {
473 # The temporary file has no (and must have no) security
474 # implications.
475 tmp=${TMPDIR:-/tmp}
476 stderr="$tmp/git-external-stderr.$$.tmp"
477 test_external "$@" 4> "$stderr"
478 test -f "$stderr" || error "Internal error: $stderr disappeared."
479 descr="no stderr: $1"
480 shift
481 say >&3 "# expecting no stderr from previous command"
482 if test ! -s "$stderr"
483 then
484 rm "$stderr"
485
486 if test $test_external_has_tap -eq 0; then
487 test_ok_ "$descr"
488 else
489 say_color "" "# test_external_without_stderr test $descr was ok"
490 test_success=$(($test_success + 1))
491 fi
492 else
493 if test "$verbose" = t
494 then
495 output=$(echo; echo "# Stderr is:"; cat "$stderr")
496 else
497 output=
498 fi
499 # rm first in case test_failure exits.
500 rm "$stderr"
501 if test $test_external_has_tap -eq 0; then
502 test_failure_ "$descr" "$@" "$output"
503 else
504 say_color error "# test_external_without_stderr test $descr failed: $@: $output"
505 test_failure=$(($test_failure + 1))
506 fi
507 fi
508 }
509
510 # debugging-friendly alternatives to "test [-f|-d|-e]"
511 # The commands test the existence or non-existence of $1. $2 can be
512 # given to provide a more precise diagnosis.
513 test_path_is_file () {
514 if ! test -f "$1"
515 then
516 echo "File $1 doesn't exist. $2"
517 false
518 fi
519 }
520
521 test_path_is_dir () {
522 if ! test -d "$1"
523 then
524 echo "Directory $1 doesn't exist. $2"
525 false
526 fi
527 }
528
529 # Check if the directory exists and is empty as expected, barf otherwise.
530 test_dir_is_empty () {
531 test_path_is_dir "$1" &&
532 if test -n "$(ls -a1 "$1" | egrep -v '^\.\.?$')"
533 then
534 echo "Directory '$1' is not empty, it contains:"
535 ls -la "$1"
536 return 1
537 fi
538 }
539
540 test_path_is_missing () {
541 if test -e "$1"
542 then
543 echo "Path exists:"
544 ls -ld "$1"
545 if test $# -ge 1
546 then
547 echo "$*"
548 fi
549 false
550 fi
551 }
552
553 # test_line_count checks that a file has the number of lines it
554 # ought to. For example:
555 #
556 # test_expect_success 'produce exactly one line of output' '
557 # do something >output &&
558 # test_line_count = 1 output
559 # '
560 #
561 # is like "test $(wc -l <output) = 1" except that it passes the
562 # output through when the number of lines is wrong.
563
564 test_line_count () {
565 if test $# != 3
566 then
567 error "bug in the test script: not 3 parameters to test_line_count"
568 elif ! test $(wc -l <"$3") "$1" "$2"
569 then
570 echo "test_line_count: line count for $3 !$1 $2"
571 cat "$3"
572 return 1
573 fi
574 }
575
576 # Returns success if a comma separated string of keywords ($1) contains a
577 # given keyword ($2).
578 # Examples:
579 # `list_contains "foo,bar" bar` returns 0
580 # `list_contains "foo" bar` returns 1
581
582 list_contains () {
583 case ",$1," in
584 *,$2,*)
585 return 0
586 ;;
587 esac
588 return 1
589 }
590
591 # This is not among top-level (test_expect_success | test_expect_failure)
592 # but is a prefix that can be used in the test script, like:
593 #
594 # test_expect_success 'complain and die' '
595 # do something &&
596 # do something else &&
597 # test_must_fail git checkout ../outerspace
598 # '
599 #
600 # Writing this as "! git checkout ../outerspace" is wrong, because
601 # the failure could be due to a segv. We want a controlled failure.
602
603 test_must_fail () {
604 case "$1" in
605 ok=*)
606 _test_ok=${1#ok=}
607 shift
608 ;;
609 *)
610 _test_ok=
611 ;;
612 esac
613 "$@"
614 exit_code=$?
615 if test $exit_code -eq 0 && ! list_contains "$_test_ok" success
616 then
617 echo >&2 "test_must_fail: command succeeded: $*"
618 return 1
619 elif test_match_signal 13 $exit_code && list_contains "$_test_ok" sigpipe
620 then
621 return 0
622 elif test $exit_code -gt 129 && test $exit_code -le 192
623 then
624 echo >&2 "test_must_fail: died by signal $(($exit_code - 128)): $*"
625 return 1
626 elif test $exit_code -eq 127
627 then
628 echo >&2 "test_must_fail: command not found: $*"
629 return 1
630 elif test $exit_code -eq 126
631 then
632 echo >&2 "test_must_fail: valgrind error: $*"
633 return 1
634 fi
635 return 0
636 }
637
638 # Similar to test_must_fail, but tolerates success, too. This is
639 # meant to be used in contexts like:
640 #
641 # test_expect_success 'some command works without configuration' '
642 # test_might_fail git config --unset all.configuration &&
643 # do something
644 # '
645 #
646 # Writing "git config --unset all.configuration || :" would be wrong,
647 # because we want to notice if it fails due to segv.
648
649 test_might_fail () {
650 test_must_fail ok=success "$@"
651 }
652
653 # Similar to test_must_fail and test_might_fail, but check that a
654 # given command exited with a given exit code. Meant to be used as:
655 #
656 # test_expect_success 'Merge with d/f conflicts' '
657 # test_expect_code 1 git merge "merge msg" B master
658 # '
659
660 test_expect_code () {
661 want_code=$1
662 shift
663 "$@"
664 exit_code=$?
665 if test $exit_code = $want_code
666 then
667 return 0
668 fi
669
670 echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
671 return 1
672 }
673
674 # test_cmp is a helper function to compare actual and expected output.
675 # You can use it like:
676 #
677 # test_expect_success 'foo works' '
678 # echo expected >expected &&
679 # foo >actual &&
680 # test_cmp expected actual
681 # '
682 #
683 # This could be written as either "cmp" or "diff -u", but:
684 # - cmp's output is not nearly as easy to read as diff -u
685 # - not all diff versions understand "-u"
686
687 test_cmp() {
688 $GIT_TEST_CMP "$@"
689 }
690
691 # test_cmp_bin - helper to compare binary files
692
693 test_cmp_bin() {
694 cmp "$@"
695 }
696
697 # Call any command "$@" but be more verbose about its
698 # failure. This is handy for commands like "test" which do
699 # not output anything when they fail.
700 verbose () {
701 "$@" && return 0
702 echo >&2 "command failed: $(git rev-parse --sq-quote "$@")"
703 return 1
704 }
705
706 # Check if the file expected to be empty is indeed empty, and barfs
707 # otherwise.
708
709 test_must_be_empty () {
710 if test -s "$1"
711 then
712 echo "'$1' is not empty, it contains:"
713 cat "$1"
714 return 1
715 fi
716 }
717
718 # Tests that its two parameters refer to the same revision
719 test_cmp_rev () {
720 git rev-parse --verify "$1" >expect.rev &&
721 git rev-parse --verify "$2" >actual.rev &&
722 test_cmp expect.rev actual.rev
723 }
724
725 # Print a sequence of integers in increasing order, either with
726 # two arguments (start and end):
727 #
728 # test_seq 1 5 -- outputs 1 2 3 4 5 one line at a time
729 #
730 # or with one argument (end), in which case it starts counting
731 # from 1.
732
733 test_seq () {
734 case $# in
735 1) set 1 "$@" ;;
736 2) ;;
737 *) error "bug in the test script: not 1 or 2 parameters to test_seq" ;;
738 esac
739 test_seq_counter__=$1
740 while test "$test_seq_counter__" -le "$2"
741 do
742 echo "$test_seq_counter__"
743 test_seq_counter__=$(( $test_seq_counter__ + 1 ))
744 done
745 }
746
747 # This function can be used to schedule some commands to be run
748 # unconditionally at the end of the test to restore sanity:
749 #
750 # test_expect_success 'test core.capslock' '
751 # git config core.capslock true &&
752 # test_when_finished "git config --unset core.capslock" &&
753 # hello world
754 # '
755 #
756 # That would be roughly equivalent to
757 #
758 # test_expect_success 'test core.capslock' '
759 # git config core.capslock true &&
760 # hello world
761 # git config --unset core.capslock
762 # '
763 #
764 # except that the greeting and config --unset must both succeed for
765 # the test to pass.
766 #
767 # Note that under --immediate mode, no clean-up is done to help diagnose
768 # what went wrong.
769
770 test_when_finished () {
771 # We cannot detect when we are in a subshell in general, but by
772 # doing so on Bash is better than nothing (the test will
773 # silently pass on other shells).
774 test "${BASH_SUBSHELL-0}" = 0 ||
775 error "bug in test script: test_when_finished does nothing in a subshell"
776 test_cleanup="{ $*
777 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
778 }
779
780 # Most tests can use the created repository, but some may need to create more.
781 # Usage: test_create_repo <directory>
782 test_create_repo () {
783 test "$#" = 1 ||
784 error "bug in the test script: not 1 parameter to test-create-repo"
785 repo="$1"
786 mkdir -p "$repo"
787 (
788 cd "$repo" || error "Cannot setup test environment"
789 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
790 error "cannot run git init -- have you built things yet?"
791 mv .git/hooks .git/hooks-disabled
792 ) || exit
793 }
794
795 # This function helps on symlink challenged file systems when it is not
796 # important that the file system entry is a symbolic link.
797 # Use test_ln_s_add instead of "ln -s x y && git add y" to add a
798 # symbolic link entry y to the index.
799
800 test_ln_s_add () {
801 if test_have_prereq SYMLINKS
802 then
803 ln -s "$1" "$2" &&
804 git update-index --add "$2"
805 else
806 printf '%s' "$1" >"$2" &&
807 ln_s_obj=$(git hash-object -w "$2") &&
808 git update-index --add --cacheinfo 120000 $ln_s_obj "$2" &&
809 # pick up stat info from the file
810 git update-index "$2"
811 fi
812 }
813
814 # This function writes out its parameters, one per line
815 test_write_lines () {
816 printf "%s\n" "$@"
817 }
818
819 perl () {
820 command "$PERL_PATH" "$@"
821 }
822
823 # Is the value one of the various ways to spell a boolean true/false?
824 test_normalize_bool () {
825 git -c magic.variable="$1" config --bool magic.variable 2>/dev/null
826 }
827
828 # Given a variable $1, normalize the value of it to one of "true",
829 # "false", or "auto" and store the result to it.
830 #
831 # test_tristate GIT_TEST_HTTPD
832 #
833 # A variable set to an empty string is set to 'false'.
834 # A variable set to 'false' or 'auto' keeps its value.
835 # Anything else is set to 'true'.
836 # An unset variable defaults to 'auto'.
837 #
838 # The last rule is to allow people to set the variable to an empty
839 # string and export it to decline testing the particular feature
840 # for versions both before and after this change. We used to treat
841 # both unset and empty variable as a signal for "do not test" and
842 # took any non-empty string as "please test".
843
844 test_tristate () {
845 if eval "test x\"\${$1+isset}\" = xisset"
846 then
847 # explicitly set
848 eval "
849 case \"\$$1\" in
850 '') $1=false ;;
851 auto) ;;
852 *) $1=\$(test_normalize_bool \$$1 || echo true) ;;
853 esac
854 "
855 else
856 eval "$1=auto"
857 fi
858 }
859
860 # Exit the test suite, either by skipping all remaining tests or by
861 # exiting with an error. If "$1" is "auto", we then we assume we were
862 # opportunistically trying to set up some tests and we skip. If it is
863 # "true", then we report a failure.
864 #
865 # The error/skip message should be given by $2.
866 #
867 test_skip_or_die () {
868 case "$1" in
869 auto)
870 skip_all=$2
871 test_done
872 ;;
873 true)
874 error "$2"
875 ;;
876 *)
877 error "BUG: test tristate is '$1' (real error: $2)"
878 esac
879 }
880
881 # The following mingw_* functions obey POSIX shell syntax, but are actually
882 # bash scripts, and are meant to be used only with bash on Windows.
883
884 # A test_cmp function that treats LF and CRLF equal and avoids to fork
885 # diff when possible.
886 mingw_test_cmp () {
887 # Read text into shell variables and compare them. If the results
888 # are different, use regular diff to report the difference.
889 local test_cmp_a= test_cmp_b=
890
891 # When text came from stdin (one argument is '-') we must feed it
892 # to diff.
893 local stdin_for_diff=
894
895 # Since it is difficult to detect the difference between an
896 # empty input file and a failure to read the files, we go straight
897 # to diff if one of the inputs is empty.
898 if test -s "$1" && test -s "$2"
899 then
900 # regular case: both files non-empty
901 mingw_read_file_strip_cr_ test_cmp_a <"$1"
902 mingw_read_file_strip_cr_ test_cmp_b <"$2"
903 elif test -s "$1" && test "$2" = -
904 then
905 # read 2nd file from stdin
906 mingw_read_file_strip_cr_ test_cmp_a <"$1"
907 mingw_read_file_strip_cr_ test_cmp_b
908 stdin_for_diff='<<<"$test_cmp_b"'
909 elif test "$1" = - && test -s "$2"
910 then
911 # read 1st file from stdin
912 mingw_read_file_strip_cr_ test_cmp_a
913 mingw_read_file_strip_cr_ test_cmp_b <"$2"
914 stdin_for_diff='<<<"$test_cmp_a"'
915 fi
916 test -n "$test_cmp_a" &&
917 test -n "$test_cmp_b" &&
918 test "$test_cmp_a" = "$test_cmp_b" ||
919 eval "diff -u \"\$@\" $stdin_for_diff"
920 }
921
922 # $1 is the name of the shell variable to fill in
923 mingw_read_file_strip_cr_ () {
924 # Read line-wise using LF as the line separator
925 # and use IFS to strip CR.
926 local line
927 while :
928 do
929 if IFS=$'\r' read -r -d $'\n' line
930 then
931 # good
932 line=$line$'\n'
933 else
934 # we get here at EOF, but also if the last line
935 # was not terminated by LF; in the latter case,
936 # some text was read
937 if test -z "$line"
938 then
939 # EOF, really
940 break
941 fi
942 fi
943 eval "$1=\$$1\$line"
944 done
945 }
946
947 # Like "env FOO=BAR some-program", but run inside a subshell, which means
948 # it also works for shell functions (though those functions cannot impact
949 # the environment outside of the test_env invocation).
950 test_env () {
951 (
952 while test $# -gt 0
953 do
954 case "$1" in
955 *=*)
956 eval "${1%%=*}=\${1#*=}"
957 eval "export ${1%%=*}"
958 shift
959 ;;
960 *)
961 "$@"
962 exit
963 ;;
964 esac
965 done
966 )
967 }
968
969 # Returns true if the numeric exit code in "$2" represents the expected signal
970 # in "$1". Signals should be given numerically.
971 test_match_signal () {
972 if test "$2" = "$((128 + $1))"
973 then
974 # POSIX
975 return 0
976 elif test "$2" = "$((256 + $1))"
977 then
978 # ksh
979 return 0
980 fi
981 return 1
982 }
983
984 # Read up to "$1" bytes (or to EOF) from stdin and write them to stdout.
985 test_copy_bytes () {
986 perl -e '
987 my $len = $ARGV[1];
988 while ($len > 0) {
989 my $s;
990 my $nread = sysread(STDIN, $s, $len);
991 die "cannot read: $!" unless defined($nread);
992 print $s;
993 $len -= $nread;
994 }
995 ' - "$1"
996 }